{{- $cpnt := .Values.apiserver }}
{{- if $cpnt.ingress.enabled }}
{{- $ingress := $cpnt.ingress.api }}
{{- if and $ingress.className (not (semverCompare ">=1.18-0" .Capabilities.KubeVersion.GitVersion)) }}
  {{- if not (hasKey $ingress.annotations "kubernetes.io/ingress.class") }}
  {{- $_ := set $ingress.annotations "kubernetes.io/ingress.class" $ingress.className}}
  {{- end }}
{{- end }}
{{- if semverCompare ">=1.19-0" .Capabilities.KubeVersion.GitVersion -}}
apiVersion: networking.k8s.io/v1
{{- else if semverCompare ">=1.14-0" .Capabilities.KubeVersion.GitVersion -}}
apiVersion: networking.k8s.io/v1beta1
{{- else -}}
apiVersion: extensions/v1beta1
{{- end }}
kind: Ingress
metadata:
  name: {{ $cpnt.component }}-api
  labels:
    {{- include "portal.labels" . | nindent 4 }}
  annotations:
  {{- with $ingress.annotations }}
    {{- toYaml . | nindent 4 }}
  {{- end }}
    cert-manager.io/cluster-issuer: {{ include "portal.certIssuer" . }}
spec:
  {{- if and $ingress.className (semverCompare ">=1.18-0" .Capabilities.KubeVersion.GitVersion) }}
  ingressClassName: {{ $ingress.className }}
  {{- end }}
  {{- if $ingress.tlsSecret }}
  tls:
    - hosts:
        - {{ $ingress.endpoint }}
      secretName: {{ $ingress.tlsSecret }}
  {{- end }}
  rules:
    - host: {{ $ingress.endpoint }}
      http:
        paths:
          - path: /
            pathType: Prefix
            backend:
              service:
                name: apiserver
                port:
                  number: 8081
          - path: /metrics
            pathType: Prefix
            backend:
              service:
                name: stats
                port:
                  number: 80
{{- end }}
